/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreUmlsimportRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSONB;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreUmlsimport extends TableImpl<VCoreUmlsimportRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_umlsimport</code>
     */
    public static final VCoreUmlsimport V_CORE_UMLSIMPORT = new VCoreUmlsimport();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreUmlsimportRecord> getRecordType() {
        return VCoreUmlsimportRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_umlsimport.content</code>.
     */
    public final TableField<VCoreUmlsimportRecord, JSONB> CONTENT = createField(DSL.name("content"), SQLDataType.JSONB, this, "");

    private VCoreUmlsimport(Name alias, Table<VCoreUmlsimportRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreUmlsimport(Name alias, Table<VCoreUmlsimportRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_umlsimport" as  SELECT ((content ->> 'content'::text))::jsonb AS content
        FROM common_dd.t_core_umlsimport;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_umlsimport</code> table
     * reference
     */
    public VCoreUmlsimport(String alias) {
        this(DSL.name(alias), V_CORE_UMLSIMPORT);
    }

    /**
     * Create an aliased <code>common_dd.v_core_umlsimport</code> table
     * reference
     */
    public VCoreUmlsimport(Name alias) {
        this(alias, V_CORE_UMLSIMPORT);
    }

    /**
     * Create a <code>common_dd.v_core_umlsimport</code> table reference
     */
    public VCoreUmlsimport() {
        this(DSL.name("v_core_umlsimport"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreUmlsimport as(String alias) {
        return new VCoreUmlsimport(DSL.name(alias), this);
    }

    @Override
    public VCoreUmlsimport as(Name alias) {
        return new VCoreUmlsimport(alias, this);
    }

    @Override
    public VCoreUmlsimport as(Table<?> alias) {
        return new VCoreUmlsimport(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUmlsimport rename(String name) {
        return new VCoreUmlsimport(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUmlsimport rename(Name name) {
        return new VCoreUmlsimport(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreUmlsimport rename(Table<?> name) {
        return new VCoreUmlsimport(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmlsimport where(Condition condition) {
        return new VCoreUmlsimport(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmlsimport where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmlsimport where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmlsimport where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmlsimport where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmlsimport where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmlsimport where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreUmlsimport where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmlsimport whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreUmlsimport whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
